source("basic.r")

logit.norm.ecm <- function(formula.short, formula.long, formula.hetero, ...){
# extract variables
  model <- model.frame(formula.short)
    y <- model.extract(model, "response")
    y <- as.matrix(y)
    y.lag <- mylag(y)[-1,]
    y <- y[-1,]
    obs <- length(y)
  x1 <- as.matrix(model.matrix(formula.short))
  x1 <- mydif(x1)[-1,]
  x1[,1] <- c(rep(1, obs))
    colnames(x1)[1] <- "beta0"
  x2 <- as.matrix(model.matrix(formula.long))
    x2 <- mylag(x2)[-1,-1]
  x <- cbind(x1, x2) 
    k <- ncol(x)
  z <- as.matrix(model.matrix(formula.hetero))[-1,]
    colnames(z)[1] <- "eta0"
    k2 <- ncol(z)
llik <- function(par, y, y.lag, x, z){
# set up
k <- ncol(x); k2 <- ncol(z)
# extract parameters
beta <- par[1:k]
delta <- par[k+1]
eta <- par[(k+2):(k+k2+1)]
mu <- (x%*%beta)+(y.lag*delta)
sigma2 <- exp(z%*%eta)
sum(-(log(2*pi*sigma2)/2)-(((y-mu)^2)/(2*sigma2)))# plus or minus
}
# optimization
x.start <- cbind(x[,-1], y.lag)
start <- glm(y ~ x.start, family=gaussian)$coefficients
res <- optim(c(start, rep(0, k2)), llik, method = "BFGS",
  hessian = TRUE, control = list(fnscale = -1),
  y = y, y.lag=y.lag, x = x, z = z)
  names(res$par) <- c(colnames(x), "delta", colnames(z))
#output
beta <- res$par[1:k]
delta <- res$par[k+1]
eta <- res$par[(k+2):(k+k2+1)]
mu <- (x%*%beta)+(y.lag*delta)
sigma2 <- exp(z%*%eta)
  res$mu <- mu
  res$sigma2 <- sigma2
  res$y <- y
res
}
report <- function(out){
se <- sqrt(diag(-solve(out$hessian)))
z0 <- out$par/se
p0 <- 2*(0.5-abs(pnorm(z0)-0.5))
res <- round(cbind(out$par, se,  z0, p0),3)
res
}
